AFLDExists = true

SpyPlaneTargetPlayer = 0
ParadropLZs = { ParaLZ1.CenterPosition, ParaLZ2.CenterPosition, ParaLZ3.CenterPosition, ParaLZ4.CenterPosition, ParaLZ5.CenterPosition, ParaLZ6.CenterPosition, ParaLZ7.CenterPosition, ParaLZ8.CenterPosition }
ParaBombsTargetPlayer = 0

ChooseAFL1 =
{
	{ type = "afld.ukraine", pos = CPos.New(84, 71), cost = 500 }
}

BuildAFL1 = function()
	if not CheckExistenceForFAC1() then
		Trigger.AfterDelay(DateTime.Seconds(1), BuildAFL1)
		return
	end

	for i,v in ipairs(ChooseAFL1) do
		if not v.exists then
			PlaceAFL1(v)
			return
		end
	end

	Trigger.AfterDelay(DateTime.Seconds(5), BuildAFL1)
end

PlaceAFL1 = function(building)
	Trigger.AfterDelay(Actor.BuildTime(building.type), function()
		if not CheckExistenceForFAC1() then
			Trigger.AfterDelay(DateTime.Seconds(1), BuildAFL1)
			return
		elseif Player1.Resources <= 299 then
			Trigger.AfterDelay(DateTime.Seconds(1),BuildAFL1)
			return
		end

		local actor = Actor.Create(building.type, true, { Owner = Player1, Location = building.pos })
		Player1.Cash = Player1.Cash - building.cost

		building.exists = true
		AFLDExists = true

		Trigger.OnRemovedFromWorld(actor, function() building.exists = false AFLDExists = false end)
		Trigger.OnDamaged(actor, function(building)
			if building.Owner == Player1 and building.Health < building.MaxHealth * 3/4 then
				building.StartBuildingRepairs()
			end
			if building.Owner == Player1 and building.Health < building.MaxHealth * 1/4 then
				building.Sell()
			end

			SendDefence()
		end)

		Trigger.AfterDelay(DateTime.Seconds(1), BuildAFL1)
	end)
end

CheckHealthForAFL1 = function()
	Trigger.AfterDelay(DateTime.Seconds(150), ApplySpyPlanePower)
	Trigger.AfterDelay(DateTime.Minutes(5), ApplyParaTrooperPower)
	Trigger.AfterDelay(DateTime.Minutes(5), ApplyParaBombsPower)

	Trigger.OnDamaged(AFL1, function()
		if AFL1.Owner == Player1 and AFL1.Health < AFL1.MaxHealth * 3/4 then
			AFL1.StartBuildingRepairs()
		end
		if AFL1.Owner == Player1 and AFL1.Health < AFL1.MaxHealth * 1/4 then
			AFL1.Sell()
		end

		SendDefence()
	end)

	Trigger.OnRemovedFromWorld(AFL1, function() BuildAFL1() AFLDExists = false end)
end

ApplySpyPlanePower = function()
	local Airfield = Player1.GetActorsByType("afld.ukraine")
	if #Airfield > 0 then
		Utils.Do(Airfield, function(afld)
			SpyPlaneTargetPlayer = SpyPlaneTargetPlayer + 1
			if SpyPlaneTargetPlayer > 8 then
				SpyPlaneTargetPlayer = 1
			end

			if SpyPlaneTargetPlayer == 1 then
				if Player2 then
					local targets = Utils.Where(Player2.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						SpyPlaneTargetPlayer = 2
					end
				end
				if not Player2 then
					SpyPlaneTargetPlayer = 2
				end
			end
			if SpyPlaneTargetPlayer == 2 then
				if Player3 then
					local targets = Utils.Where(Player3.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						SpyPlaneTargetPlayer = 3
					end
				end
				if not Player3 then
					SpyPlaneTargetPlayer = 3
				end
			end
			if SpyPlaneTargetPlayer == 3 then
				if Player4 then
					local targets = Utils.Where(Player4.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						SpyPlaneTargetPlayer = 4
					end
				end
				if not Player4 then
					SpyPlaneTargetPlayer = 4
				end
			end
			if SpyPlaneTargetPlayer == 4 then
				if Player5 then
					local targets = Utils.Where(Player5.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						SpyPlaneTargetPlayer = 5
					end
				end
				if not Player5 then
					SpyPlaneTargetPlayer = 5
				end
			end
			if SpyPlaneTargetPlayer == 5 then
				if Player6 then
					local targets = Utils.Where(Player6.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						SpyPlaneTargetPlayer = 6
					end
				end
				if not Player6 then
					SpyPlaneTargetPlayer = 6
				end
			end
			if SpyPlaneTargetPlayer == 6 then
				if Player7 then
					local targets = Utils.Where(Player7.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						SpyPlaneTargetPlayer = 7
					end
				end
				if not Player7 then
					SpyPlaneTargetPlayer = 7
				end
			end
			if SpyPlaneTargetPlayer == 7 then
				if Player8 then
					local targets = Utils.Where(Player8.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						SpyPlaneTargetPlayer = 8
					end
				end
				if not Player8 then
					SpyPlaneTargetPlayer = 8
				end
			end
			if SpyPlaneTargetPlayer == 8 then
				if Player9 then
					local targets = Utils.Where(Player9.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						Trigger.AfterDelay(DateTime.Seconds(1), ApplySpyPlanePower)
						return
					end
				end
				if not Player9 then
					Trigger.AfterDelay(DateTime.Seconds(1), ApplySpyPlanePower)
					return
				end
			end

			Trigger.AfterDelay(DateTime.Seconds(150), ApplySpyPlanePower)
		end)
	end
	if #Airfield < 1 then
		Trigger.AfterDelay(DateTime.Seconds(150), ApplySpyPlanePower)
	end
end

ApplyParaTrooperPower = function()
	local Airfield = Player1.GetActorsByType("afld.ukraine")
	if #Airfield > 0 then
		local powerproxy = Actor.Create("powerproxy.paratroopers", false, { Owner = Player1 })
		local units = powerproxy.SendParatroopers(Utils.Random(ParadropLZs), false, 28)
		Utils.Do(units, function(unit)
			Trigger.OnAddedToWorld(unit, SendAttack)
		end)
		powerproxy.Destroy()
	end

	Trigger.AfterDelay(DateTime.Minutes(5), ApplyParaTrooperPower)
end

ApplyParaBombsPower = function()
	local HomeAirfield = Player1.GetActorsByType("afld.ukraine")
	if #HomeAirfield > 0 then
		local DistantAirfield = Player1.GetActorsByType("afld.production")
		Utils.Do(DistantAirfield, function(afld)
			ParaBombsTargetPlayer = ParaBombsTargetPlayer + 1
			if ParaBombsTargetPlayer > 8 then
				ParaBombsTargetPlayer = 1
			end

			if ParaBombsTargetPlayer == 1 then
				if Player2 then
					local targets = Utils.Where(Player2.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						ParaBombsTargetPlayer = 2
					end
				end
				if not Player2 then
					ParaBombsTargetPlayer = 2
				end
			end
			if ParaBombsTargetPlayer == 2 then
				if Player3 then
					local targets = Utils.Where(Player3.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						ParaBombsTargetPlayer = 3
					end
				end
				if not Player3 then
					ParaBombsTargetPlayer = 3
				end
			end
			if ParaBombsTargetPlayer == 3 then
				if Player4 then
					local targets = Utils.Where(Player4.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						ParaBombsTargetPlayer = 4
					end
				end
				if not Player4 then
					ParaBombsTargetPlayer = 4
				end
			end
			if ParaBombsTargetPlayer == 4 then
				if Player5 then
					local targets = Utils.Where(Player5.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						ParaBombsTargetPlayer = 5
					end
				end
				if not Player5 then
					ParaBombsTargetPlayer = 5
				end
			end
			if ParaBombsTargetPlayer == 5 then
				if Player6 then
					local targets = Utils.Where(Player6.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						ParaBombsTargetPlayer = 6
					end
				end
				if not Player6 then
					ParaBombsTargetPlayer = 6
				end
			end
			if ParaBombsTargetPlayer == 6 then
				if Player7 then
					local targets = Utils.Where(Player7.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						ParaBombsTargetPlayer = 7
					end
				end
				if not Player7 then
					ParaBombsTargetPlayer = 7
				end
			end
			if ParaBombsTargetPlayer == 7 then
				if Player8 then
					local targets = Utils.Where(Player8.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						ParaBombsTargetPlayer = 8
					end
				end
				if not Player8 then
					ParaBombsTargetPlayer = 8
				end
			end
			if ParaBombsTargetPlayer == 8 then
				if Player9 then
					local targets = Utils.Where(Player9.GetActors(), function(actor)
						return 
							actor.HasProperty("Sell") and 
							actor.Type ~= "brik" and
							actor.Type ~= "sbag" or
							actor.Type == "pdox" or
							actor.Type == "atek"
					end)

					if #targets > 0 then
						afld.SendAirstrike(Utils.Random(targets).CenterPosition, true, 0)
					end
					if #targets < 1 then
						Trigger.AfterDelay(DateTime.Seconds(1), ApplyParaBombsPower)
						return
					end
				end
				if not Player9 then
					Trigger.AfterDelay(DateTime.Seconds(1), ApplyParaBombsPower)
					return
				end
			end

			Trigger.AfterDelay(DateTime.Minutes(5), ApplyParaBombsPower)
		end)
	end
	if #HomeAirfield < 1 then
		Trigger.AfterDelay(DateTime.Minutes(5), ApplyParaBombsPower)
	end
end